JUCE: dsp::SIMDRegister< Type > Struct Template Reference

JUCE

Classes | Public Types | Public Member Functions | Static Public Member Functions | Public Attributes | Static Public Attributes | List of all members
dsp::SIMDRegister< Type > Struct Template Reference
juce_dsp » containers

A wrapper around the platform's native SIMD register type. More...

`#include <juce_SIMDRegister.h>`

## Classes
struct | ElementAccess

## Public Types
using | ElementType = Type
| The type that represents the individual constituents of the SIMD Register. More...
using | value_type = ElementType
| STL compatible value_type definition (same as ElementType). More...
using | MaskType = typename SIMDInternal::MaskTypeFor< ElementType >::type
| The corresponding primitive integer type, for example, this will be int32_t if type is a float. More...
using | PrimitiveType = typename SIMDInternal::PrimitiveType< ElementType >::type
| The native primitive type (used internally). More...
using | NativeOps = SIMDNativeOps< PrimitiveType >
| The native operations for this platform and type combination (used internally) More...
using | vSIMDType = typename NativeOps::vSIMDType
| The native type (used internally). More...
using | vMaskType = SIMDRegister< MaskType >
| The corresponding integer SIMDRegister type (used internally). More...
using | vMaskSIMDType = typename vMaskType::vSIMDType
| The internal native type for the corresponding mask type (used internally). More...
using | CmplxOps = CmplxSIMDOps< ElementType >
| Wrapper for operations which need to be handled differently for complex and scalar types (used internally). More...

## Public Member Functions
| SIMDRegister () noexcept=default
| Default constructor. More...
| SIMDRegister (vSIMDType a) noexcept
| Constructs an object from the native SIMD type. More...
| SIMDRegister (Type s) noexcept
| Constructs an object from a scalar type by broadcasting it to all elements. More...
void JUCE_VECTOR_CALLTYPE | copyToRawArray (ElementType *a) const noexcept
| Copies the elements of the SIMDRegister to a scalar array in memory. More...
ElementType JUCE_VECTOR_CALLTYPE | get (size_t idx) const noexcept
| Returns the idx-th element of the receiver. More...
void JUCE_VECTOR_CALLTYPE | set (size_t idx, ElementType v) noexcept
| Sets the idx-th element of the receiver. More...
ElementType JUCE_VECTOR_CALLTYPE | operator[] (size_t idx) const noexcept
| Returns the idx-th element of the receiver. More...
ElementAccess JUCE_VECTOR_CALLTYPE | operator[] (size_t idx) noexcept
| Returns the idx-th element of the receiver. More...
SIMDRegister &JUCE_VECTOR_CALLTYPE | operator+= (SIMDRegister v) noexcept
| Adds another SIMDRegister to the receiver. More...
SIMDRegister &JUCE_VECTOR_CALLTYPE | operator-= (SIMDRegister v) noexcept
| Subtracts another SIMDRegister to the receiver. More...
SIMDRegister &JUCE_VECTOR_CALLTYPE | operator*= (SIMDRegister v) noexcept
| Multiplies another SIMDRegister to the receiver. More...
SIMDRegister &JUCE_VECTOR_CALLTYPE | operator= (ElementType s) noexcept
| Broadcasts the scalar to all elements of the receiver. More...
SIMDRegister &JUCE_VECTOR_CALLTYPE | operator+= (ElementType s) noexcept
| Adds a scalar to the receiver. More...
SIMDRegister &JUCE_VECTOR_CALLTYPE | operator-= (ElementType s) noexcept
| Subtracts a scalar to the receiver. More...
SIMDRegister &JUCE_VECTOR_CALLTYPE | operator*= (ElementType s) noexcept
| Multiplies a scalar to the receiver. More...
SIMDRegister &JUCE_VECTOR_CALLTYPE | operator&= (vMaskType v) noexcept
| Bit-and the receiver with SIMDRegister v and store the result in the receiver. More...
SIMDRegister &JUCE_VECTOR_CALLTYPE | operator|= (vMaskType v) noexcept
| Bit-or the receiver with SIMDRegister v and store the result in the receiver. More...
SIMDRegister &JUCE_VECTOR_CALLTYPE | operator^= (vMaskType v) noexcept
| Bit-xor the receiver with SIMDRegister v and store the result in the receiver. More...
SIMDRegister &JUCE_VECTOR_CALLTYPE | operator&= (MaskType s) noexcept
| Bit-and each element of the receiver with the scalar s and store the result in the receiver. More...
SIMDRegister &JUCE_VECTOR_CALLTYPE | operator|= (MaskType s) noexcept
| Bit-or each element of the receiver with the scalar s and store the result in the receiver. More...
SIMDRegister &JUCE_VECTOR_CALLTYPE | operator^= (MaskType s) noexcept
| Bit-xor each element of the receiver with the scalar s and store the result in the receiver. More...
SIMDRegister JUCE_VECTOR_CALLTYPE | operator+ (SIMDRegister v) const noexcept
| Returns the sum of the receiver and v. More...
SIMDRegister JUCE_VECTOR_CALLTYPE | operator- (SIMDRegister v) const noexcept
| Returns the difference of the receiver and v. More...
SIMDRegister JUCE_VECTOR_CALLTYPE | operator* (SIMDRegister v) const noexcept
| Returns the product of the receiver and v. More...
SIMDRegister JUCE_VECTOR_CALLTYPE | operator+ (ElementType s) const noexcept
| Returns a vector where each element is the sum of the corresponding element in the receiver and the scalar s. More...
SIMDRegister JUCE_VECTOR_CALLTYPE | operator- (ElementType s) const noexcept
| Returns a vector where each element is the difference of the corresponding element in the receiver and the scalar s. More...
SIMDRegister JUCE_VECTOR_CALLTYPE | operator* (ElementType s) const noexcept
| Returns a vector where each element is the product of the corresponding element in the receiver and the scalar s. More...
SIMDRegister JUCE_VECTOR_CALLTYPE | operator& (vMaskType v) const noexcept
| Returns the bit-and of the receiver and v. More...
SIMDRegister JUCE_VECTOR_CALLTYPE | operator| (vMaskType v) const noexcept
| Returns the bit-or of the receiver and v. More...
SIMDRegister JUCE_VECTOR_CALLTYPE | operator^ (vMaskType v) const noexcept
| Returns the bit-xor of the receiver and v. More...
SIMDRegister JUCE_VECTOR_CALLTYPE | operator~ () const noexcept
| Returns a vector where each element is the bit-inverted value of the corresponding element in the receiver. More...
SIMDRegister JUCE_VECTOR_CALLTYPE | operator& (MaskType s) const noexcept
| Returns a vector where each element is the bit-and'd value of the corresponding element in the receiver and the scalar s. More...
SIMDRegister JUCE_VECTOR_CALLTYPE | operator| (MaskType s) const noexcept
| Returns a vector where each element is the bit-or'd value of the corresponding element in the receiver and the scalar s. More...
SIMDRegister JUCE_VECTOR_CALLTYPE | operator^ (MaskType s) const noexcept
| Returns a vector where each element is the bit-xor'd value of the corresponding element in the receiver and the scalar s. More...
bool JUCE_VECTOR_CALLTYPE | operator== (SIMDRegister other) const noexcept
| Returns true if all element-wise comparisons return true. More...
bool JUCE_VECTOR_CALLTYPE | operator!= (SIMDRegister other) const noexcept
| Returns true if any element-wise comparisons return false. More...
bool JUCE_VECTOR_CALLTYPE | operator== (Type s) const noexcept
| Returns true if all elements are equal to the scalar. More...
bool JUCE_VECTOR_CALLTYPE | operator!= (Type s) const noexcept
| Returns true if any elements are not equal to the scalar. More...
ElementType | sum () const noexcept
| Returns a scalar which is the sum of all elements of the receiver. More...

## Static Public Member Functions
static constexpr size_t | size () noexcept
| Returns the number of elements in this vector. More...
static SIMDRegister JUCE_VECTOR_CALLTYPE | expand (ElementType s) noexcept
| Creates a new SIMDRegister from the corresponding scalar primitive. More...
static SIMDRegister JUCE_VECTOR_CALLTYPE | fromNative (vSIMDType a) noexcept
| Creates a new SIMDRegister from the internal SIMD type (for example __mm128 for single-precision floating point on SSE architectures). More...
static SIMDRegister JUCE_VECTOR_CALLTYPE | fromRawArray (const ElementType *a) noexcept
| Creates a new SIMDRegister from the first SIMDNumElements of a scalar array. More...
static vMaskType JUCE_VECTOR_CALLTYPE | equal (SIMDRegister a, SIMDRegister b) noexcept
| Returns a SIMDRegister of the corresponding integral type where each element has each bit set if the corresponding element of a is equal to the corresponding element of b, or zero otherwise. More...
static vMaskType JUCE_VECTOR_CALLTYPE | notEqual (SIMDRegister a, SIMDRegister b) noexcept
| Returns a SIMDRegister of the corresponding integral type where each element has each bit set if the corresponding element of a is not equal to the corresponding element of b, or zero otherwise. More...
static vMaskType JUCE_VECTOR_CALLTYPE | lessThan (SIMDRegister a, SIMDRegister b) noexcept
| Returns a SIMDRegister of the corresponding integral type where each element has each bit set if the corresponding element of a is less than to the corresponding element of b, or zero otherwise. More...
static vMaskType JUCE_VECTOR_CALLTYPE | lessThanOrEqual (SIMDRegister a, SIMDRegister b) noexcept
| Returns a SIMDRegister of the corresponding integral type where each element has each bit set if the corresponding element of a is than or equal to the corresponding element of b, or zero otherwise. More...
static vMaskType JUCE_VECTOR_CALLTYPE | greaterThan (SIMDRegister a, SIMDRegister b) noexcept
| Returns a SIMDRegister of the corresponding integral type where each element has each bit set if the corresponding element of a is greater than to the corresponding element of b, or zero otherwise. More...
static vMaskType JUCE_VECTOR_CALLTYPE | greaterThanOrEqual (SIMDRegister a, SIMDRegister b) noexcept
| Returns a SIMDRegister of the corresponding integral type where each element has each bit set if the corresponding element of a is greater than or equal to the corresponding element of b, or zero otherwise. More...
static SIMDRegister JUCE_VECTOR_CALLTYPE | min (SIMDRegister a, SIMDRegister b) noexcept
| Returns a new vector where each element is the minimum of the corresponding element of a and b. More...
static SIMDRegister JUCE_VECTOR_CALLTYPE | max (SIMDRegister a, SIMDRegister b) noexcept
| Returns a new vector where each element is the maximum of the corresponding element of a and b. More...
static SIMDRegister JUCE_VECTOR_CALLTYPE | multiplyAdd (SIMDRegister a, const SIMDRegister b, SIMDRegister c) noexcept
| Multiplies b and c and adds the result to a. More...
static SIMDRegister JUCE_VECTOR_CALLTYPE | truncate (SIMDRegister a) noexcept
| Truncates each element to its integer part. More...
static SIMDRegister JUCE_VECTOR_CALLTYPE | abs (SIMDRegister a) noexcept
| Returns the absolute value of each element. More...
static bool | isSIMDAligned (const ElementType *ptr) noexcept
| Checks if the given pointer is sufficiently aligned for using SIMD operations. More...
static ElementType * | getNextSIMDAlignedPtr (ElementType *ptr) noexcept
| Returns the next position in memory where isSIMDAligned returns true. More...

## Public Attributes
vSIMDType | value

## Static Public Attributes
static constexpr size_t | SIMDRegisterSize = sizeof (vSIMDType)
| The size in bytes of this register. More...
static constexpr size_t | SIMDNumElements = SIMDRegisterSize / sizeof (ElementType)
| The number of elements that this vector can hold. More...

## Detailed Description

template<typename Type>
struct dsp::SIMDRegister< Type >

A wrapper around the platform's native SIMD register type.

This class is only available on SIMD machines. Use JUCE_USE_SIMD to query if SIMD is available for your system.

SIMDRegister<Type> is a templated class representing the native vectorized version of FloatingType. SIMDRegister supports all numerical primitive types and std:complex<float> and std::complex<double> supports and most operations of the corresponding primitive type. Additionally, SIMDRegister can be accessed like an array to extract the individual elements.

If you are using SIMDRegister as a pointer, then you must ensure that the memory is sufficiently aligned for SIMD vector operations. Failing to do so will result in crashes or very slow code. Use SIMDRegister::isSIMDAligned to query if a pointer is sufficiently aligned for SIMD vector operations.

Note that using SIMDRegister without enabling optimizations will result in code with very poor performance.

## Member Typedef Documentation

## ◆ ElementType

template<typename Type >

using dsp::SIMDRegister< Type >::ElementType = Type

The type that represents the individual constituents of the SIMD Register.

## ◆ value_type

template<typename Type >

using dsp::SIMDRegister< Type >::value_type = ElementType

STL compatible value_type definition (same as ElementType).

## ◆ MaskType

template<typename Type >

using dsp::SIMDRegister< Type >::MaskType = typename SIMDInternal::MaskTypeFor<ElementType>::type

The corresponding primitive integer type, for example, this will be int32_t if type is a float.

## ◆ PrimitiveType

template<typename Type >

using dsp::SIMDRegister< Type >::PrimitiveType = typename SIMDInternal::PrimitiveType<ElementType>::type

The native primitive type (used internally).

## ◆ NativeOps

template<typename Type >

using dsp::SIMDRegister< Type >::NativeOps = SIMDNativeOps<PrimitiveType>

The native operations for this platform and type combination (used internally)

## ◆ vSIMDType

template<typename Type >

using dsp::SIMDRegister< Type >::vSIMDType = typename NativeOps::vSIMDType

The native type (used internally).

## ◆ vMaskType

template<typename Type >

using dsp::SIMDRegister< Type >::vMaskType = SIMDRegister<MaskType>

The corresponding integer SIMDRegister type (used internally).

## ◆ vMaskSIMDType

template<typename Type >

using dsp::SIMDRegister< Type >::vMaskSIMDType = typename vMaskType::vSIMDType

The internal native type for the corresponding mask type (used internally).

## ◆ CmplxOps

template<typename Type >

using dsp::SIMDRegister< Type >::CmplxOps = CmplxSIMDOps<ElementType>

Wrapper for operations which need to be handled differently for complex and scalar types (used internally).

## Constructor & Destructor Documentation

## ◆ SIMDRegister() [1/3]

template<typename Type >

dsp::SIMDRegister< Type >::SIMDRegister | ( |  | ) |
| defaultnoexcept

Default constructor.

## ◆ SIMDRegister() [2/3]

template<typename Type >

dsp::SIMDRegister< Type >::SIMDRegister | ( | vSIMDType | a | ) |
| noexcept

Constructs an object from the native SIMD type.

## ◆ SIMDRegister() [3/3]

template<typename Type >

dsp::SIMDRegister< Type >::SIMDRegister | ( | Type | s | ) |
| noexcept

Constructs an object from a scalar type by broadcasting it to all elements.

References gl::s.

## Member Function Documentation

## ◆ size()

template<typename Type >

static constexpr size_t dsp::SIMDRegister< Type >::size | ( |  | ) |
| staticconstexprnoexcept

Returns the number of elements in this vector.

References dsp::SIMDRegister< Type >::SIMDNumElements.

## ◆ expand()

template<typename Type >

static SIMDRegister JUCE_VECTOR_CALLTYPE dsp::SIMDRegister< Type >::expand | ( | ElementType | s | ) |
| staticnoexcept

Creates a new SIMDRegister from the corresponding scalar primitive.

The scalar is extended to all elements of the vector.

References gl::s.

Referenced by dsp::SIMDRegister< Type >::abs(), and dsp::SIMDRegister< Type >::operator==().

## ◆ fromNative()

template<typename Type >

static SIMDRegister JUCE_VECTOR_CALLTYPE dsp::SIMDRegister< Type >::fromNative | ( | vSIMDType | a | ) |
| staticnoexcept

Creates a new SIMDRegister from the internal SIMD type (for example __mm128 for single-precision floating point on SSE architectures).

References gl::a.

## ◆ fromRawArray()

template<typename Type >

static SIMDRegister JUCE_VECTOR_CALLTYPE dsp::SIMDRegister< Type >::fromRawArray | ( | const ElementType * | a | ) |
| staticnoexcept

Creates a new SIMDRegister from the first SIMDNumElements of a scalar array.

References gl::a, dsp::SIMDRegister< Type >::isSIMDAligned(), and jassert.

## ◆ copyToRawArray()

template<typename Type >

void JUCE_VECTOR_CALLTYPE dsp::SIMDRegister< Type >::copyToRawArray | ( | ElementType * | a | ) | const
| noexcept

Copies the elements of the SIMDRegister to a scalar array in memory.

References gl::a, dsp::SIMDRegister< Type >::isSIMDAligned(), jassert, and dsp::SIMDRegister< Type >::value.

## ◆ get()

template<typename Type >

ElementType JUCE_VECTOR_CALLTYPE dsp::SIMDRegister< Type >::get | ( | size_t | idx | ) | const
| noexcept

Returns the idx-th element of the receiver.

Note that this does not check if idx is larger than the native register size.

References dsp::get(), jassert, dsp::SIMDRegister< Type >::SIMDNumElements, and dsp::SIMDRegister< Type >::value.

Referenced by dsp::SIMDRegister< Type >::operator[]().

## ◆ set()

template<typename Type >

void JUCE_VECTOR_CALLTYPE dsp::SIMDRegister< Type >::set | ( | size_t | idx,
|  | ElementType | v
| ) |  |
| noexcept

Sets the idx-th element of the receiver.

Note that this does not check if idx is larger than the native register size.

References jassert, dsp::SIMDRegister< Type >::SIMDNumElements, gl::v, and dsp::SIMDRegister< Type >::value.

Referenced by dsp::SIMDRegister< Type >::ElementAccess::operator=().

## ◆ operator[]() [1/2]

template<typename Type >

ElementType JUCE_VECTOR_CALLTYPE dsp::SIMDRegister< Type >::operator[] | ( | size_t | idx | ) | const
| noexcept

Returns the idx-th element of the receiver.

Note that this does not check if idx is larger than the native register size.

References dsp::SIMDRegister< Type >::get().

## ◆ operator[]() [2/2]

template<typename Type >

ElementAccess JUCE_VECTOR_CALLTYPE dsp::SIMDRegister< Type >::operator[] | ( | size_t | idx | ) |
| noexcept

Returns the idx-th element of the receiver.

Note that this does not check if idx is larger than the native register size.

References jassert, and dsp::SIMDRegister< Type >::SIMDNumElements.

## ◆ operator+=() [1/2]

template<typename Type >

SIMDRegister &JUCE_VECTOR_CALLTYPE dsp::SIMDRegister< Type >::operator+= | ( | SIMDRegister< Type > | v | ) |
| noexcept

Adds another SIMDRegister to the receiver.

References gl::v, and dsp::SIMDRegister< Type >::value.

## ◆ operator-=() [1/2]

template<typename Type >

SIMDRegister &JUCE_VECTOR_CALLTYPE dsp::SIMDRegister< Type >::operator-= | ( | SIMDRegister< Type > | v | ) |
| noexcept

Subtracts another SIMDRegister to the receiver.

References gl::v, and dsp::SIMDRegister< Type >::value.

## ◆ operator*=() [1/2]

template<typename Type >

SIMDRegister &JUCE_VECTOR_CALLTYPE dsp::SIMDRegister< Type >::operator*= | ( | SIMDRegister< Type > | v | ) |
| noexcept

Multiplies another SIMDRegister to the receiver.

References gl::v, and dsp::SIMDRegister< Type >::value.

## ◆ operator=()

template<typename Type >

SIMDRegister &JUCE_VECTOR_CALLTYPE dsp::SIMDRegister< Type >::operator= | ( | ElementType | s | ) |
| noexcept

Broadcasts the scalar to all elements of the receiver.

References gl::s, and dsp::SIMDRegister< Type >::value.

Referenced by dsp::SIMDRegister< Type >::ElementAccess::operator=().

## ◆ operator+=() [2/2]

template<typename Type >

SIMDRegister &JUCE_VECTOR_CALLTYPE dsp::SIMDRegister< Type >::operator+= | ( | ElementType | s | ) |
| noexcept

Adds a scalar to the receiver.

References gl::s, and dsp::SIMDRegister< Type >::value.

## ◆ operator-=() [2/2]

template<typename Type >

SIMDRegister &JUCE_VECTOR_CALLTYPE dsp::SIMDRegister< Type >::operator-= | ( | ElementType | s | ) |
| noexcept

Subtracts a scalar to the receiver.

References gl::s, and dsp::SIMDRegister< Type >::value.

## ◆ operator*=() [2/2]

template<typename Type >

SIMDRegister &JUCE_VECTOR_CALLTYPE dsp::SIMDRegister< Type >::operator*= | ( | ElementType | s | ) |
| noexcept

Multiplies a scalar to the receiver.

References gl::s, and dsp::SIMDRegister< Type >::value.

## ◆ operator&=() [1/2]

template<typename Type >

SIMDRegister &JUCE_VECTOR_CALLTYPE dsp::SIMDRegister< Type >::operator&= | ( | vMaskType | v | ) |
| noexcept

Bit-and the receiver with SIMDRegister v and store the result in the receiver.

References gl::v, and dsp::SIMDRegister< Type >::value.

## ◆ operator|=() [1/2]

template<typename Type >

SIMDRegister &JUCE_VECTOR_CALLTYPE dsp::SIMDRegister< Type >::operator|= | ( | vMaskType | v | ) |
| noexcept

Bit-or the receiver with SIMDRegister v and store the result in the receiver.

References gl::v, and dsp::SIMDRegister< Type >::value.

## ◆ operator^=() [1/2]

template<typename Type >

SIMDRegister &JUCE_VECTOR_CALLTYPE dsp::SIMDRegister< Type >::operator^= | ( | vMaskType | v | ) |
| noexcept

Bit-xor the receiver with SIMDRegister v and store the result in the receiver.

References gl::v, and dsp::SIMDRegister< Type >::value.

## ◆ operator&=() [2/2]

template<typename Type >

SIMDRegister &JUCE_VECTOR_CALLTYPE dsp::SIMDRegister< Type >::operator&= | ( | MaskType | s | ) |
| noexcept

Bit-and each element of the receiver with the scalar s and store the result in the receiver.

References gl::s, and dsp::SIMDRegister< Type >::value.

## ◆ operator|=() [2/2]

template<typename Type >

SIMDRegister &JUCE_VECTOR_CALLTYPE dsp::SIMDRegister< Type >::operator|= | ( | MaskType | s | ) |
| noexcept

Bit-or each element of the receiver with the scalar s and store the result in the receiver.

References gl::s, and dsp::SIMDRegister< Type >::value.

## ◆ operator^=() [2/2]

template<typename Type >

SIMDRegister &JUCE_VECTOR_CALLTYPE dsp::SIMDRegister< Type >::operator^= | ( | MaskType | s | ) |
| noexcept

Bit-xor each element of the receiver with the scalar s and store the result in the receiver.

References gl::s, and dsp::SIMDRegister< Type >::value.

## ◆ operator+() [1/2]

template<typename Type >

SIMDRegister JUCE_VECTOR_CALLTYPE dsp::SIMDRegister< Type >::operator+ | ( | SIMDRegister< Type > | v | ) | const
| noexcept

Returns the sum of the receiver and v.

References gl::v, and dsp::SIMDRegister< Type >::value.

## ◆ operator-() [1/2]

template<typename Type >

SIMDRegister JUCE_VECTOR_CALLTYPE dsp::SIMDRegister< Type >::operator- | ( | SIMDRegister< Type > | v | ) | const
| noexcept

Returns the difference of the receiver and v.

References gl::v, and dsp::SIMDRegister< Type >::value.

## ◆ operator*() [1/2]

template<typename Type >

SIMDRegister JUCE_VECTOR_CALLTYPE dsp::SIMDRegister< Type >::operator* | ( | SIMDRegister< Type > | v | ) | const
| noexcept

Returns the product of the receiver and v.

References gl::v, and dsp::SIMDRegister< Type >::value.

## ◆ operator+() [2/2]

template<typename Type >

SIMDRegister JUCE_VECTOR_CALLTYPE dsp::SIMDRegister< Type >::operator+ | ( | ElementType | s | ) | const
| noexcept

Returns a vector where each element is the sum of the corresponding element in the receiver and the scalar s.

References gl::s, and dsp::SIMDRegister< Type >::value.

## ◆ operator-() [2/2]

template<typename Type >

SIMDRegister JUCE_VECTOR_CALLTYPE dsp::SIMDRegister< Type >::operator- | ( | ElementType | s | ) | const
| noexcept

Returns a vector where each element is the difference of the corresponding element in the receiver and the scalar s.

References gl::s, and dsp::SIMDRegister< Type >::value.

## ◆ operator*() [2/2]

template<typename Type >

SIMDRegister JUCE_VECTOR_CALLTYPE dsp::SIMDRegister< Type >::operator* | ( | ElementType | s | ) | const
| noexcept

Returns a vector where each element is the product of the corresponding element in the receiver and the scalar s.

References gl::s, and dsp::SIMDRegister< Type >::value.

## ◆ operator&() [1/2]

template<typename Type >

SIMDRegister JUCE_VECTOR_CALLTYPE dsp::SIMDRegister< Type >::operator& | ( | vMaskType | v | ) | const
| noexcept

Returns the bit-and of the receiver and v.

References gl::v, and dsp::SIMDRegister< Type >::value.

## ◆ operator|() [1/2]

template<typename Type >

SIMDRegister JUCE_VECTOR_CALLTYPE dsp::SIMDRegister< Type >::operator| | ( | vMaskType | v | ) | const
| noexcept

Returns the bit-or of the receiver and v.

References gl::v, and dsp::SIMDRegister< Type >::value.

## ◆ operator^() [1/2]

template<typename Type >

SIMDRegister JUCE_VECTOR_CALLTYPE dsp::SIMDRegister< Type >::operator^ | ( | vMaskType | v | ) | const
| noexcept

Returns the bit-xor of the receiver and v.

References gl::v, and dsp::SIMDRegister< Type >::value.

## ◆ operator~()

template<typename Type >

SIMDRegister JUCE_VECTOR_CALLTYPE dsp::SIMDRegister< Type >::operator~ | ( |  | ) | const
| noexcept

Returns a vector where each element is the bit-inverted value of the corresponding element in the receiver.

References dsp::SIMDRegister< Type >::value.

## ◆ operator&() [2/2]

template<typename Type >

SIMDRegister JUCE_VECTOR_CALLTYPE dsp::SIMDRegister< Type >::operator& | ( | MaskType | s | ) | const
| noexcept

Returns a vector where each element is the bit-and'd value of the corresponding element in the receiver and the scalar s.

References gl::s, and dsp::SIMDRegister< Type >::value.

## ◆ operator|() [2/2]

template<typename Type >

SIMDRegister JUCE_VECTOR_CALLTYPE dsp::SIMDRegister< Type >::operator| | ( | MaskType | s | ) | const
| noexcept

Returns a vector where each element is the bit-or'd value of the corresponding element in the receiver and the scalar s.

References gl::s, and dsp::SIMDRegister< Type >::value.

## ◆ operator^() [2/2]

template<typename Type >

SIMDRegister JUCE_VECTOR_CALLTYPE dsp::SIMDRegister< Type >::operator^ | ( | MaskType | s | ) | const
| noexcept

Returns a vector where each element is the bit-xor'd value of the corresponding element in the receiver and the scalar s.

References gl::s, and dsp::SIMDRegister< Type >::value.

## ◆ operator==() [1/2]

template<typename Type >

bool JUCE_VECTOR_CALLTYPE dsp::SIMDRegister< Type >::operator== | ( | SIMDRegister< Type > | other | ) | const
| noexcept

Returns true if all element-wise comparisons return true.

References dsp::SIMDRegister< Type >::value.

## ◆ operator!=() [1/2]

template<typename Type >

bool JUCE_VECTOR_CALLTYPE dsp::SIMDRegister< Type >::operator!= | ( | SIMDRegister< Type > | other | ) | const
| noexcept

Returns true if any element-wise comparisons return false.

## ◆ operator==() [2/2]

template<typename Type >

bool JUCE_VECTOR_CALLTYPE dsp::SIMDRegister< Type >::operator== | ( | Type | s | ) | const
| noexcept

Returns true if all elements are equal to the scalar.

References dsp::SIMDRegister< Type >::expand(), and gl::s.

## ◆ operator!=() [2/2]

template<typename Type >

bool JUCE_VECTOR_CALLTYPE dsp::SIMDRegister< Type >::operator!= | ( | Type | s | ) | const
| noexcept

Returns true if any elements are not equal to the scalar.

References gl::s.

## ◆ equal()

template<typename Type >

static vMaskType JUCE_VECTOR_CALLTYPE dsp::SIMDRegister< Type >::equal | ( | SIMDRegister< Type > | a,
|  | SIMDRegister< Type > | b
| ) |  |
| staticnoexcept

Returns a SIMDRegister of the corresponding integral type where each element has each bit set if the corresponding element of a is equal to the corresponding element of b, or zero otherwise.

The result can then be used in bit operations defined above to avoid branches in vector SIMD code.

References gl::a, and gl::b.

## ◆ notEqual()

template<typename Type >

static vMaskType JUCE_VECTOR_CALLTYPE dsp::SIMDRegister< Type >::notEqual | ( | SIMDRegister< Type > | a,
|  | SIMDRegister< Type > | b
| ) |  |
| staticnoexcept

Returns a SIMDRegister of the corresponding integral type where each element has each bit set if the corresponding element of a is not equal to the corresponding element of b, or zero otherwise.

The result can then be used in bit operations defined above to avoid branches in vector SIMD code.

References gl::a, and gl::b.

## ◆ lessThan()

template<typename Type >

static vMaskType JUCE_VECTOR_CALLTYPE dsp::SIMDRegister< Type >::lessThan | ( | SIMDRegister< Type > | a,
|  | SIMDRegister< Type > | b
| ) |  |
| staticnoexcept

Returns a SIMDRegister of the corresponding integral type where each element has each bit set if the corresponding element of a is less than to the corresponding element of b, or zero otherwise.

The result can then be used in bit operations defined above to avoid branches in vector SIMD code.

References gl::a, and gl::b.

Referenced by dsp::SIMDRegister< Type >::abs().

## ◆ lessThanOrEqual()

template<typename Type >

static vMaskType JUCE_VECTOR_CALLTYPE dsp::SIMDRegister< Type >::lessThanOrEqual | ( | SIMDRegister< Type > | a,
|  | SIMDRegister< Type > | b
| ) |  |
| staticnoexcept

Returns a SIMDRegister of the corresponding integral type where each element has each bit set if the corresponding element of a is than or equal to the corresponding element of b, or zero otherwise.

The result can then be used in bit operations defined above to avoid branches in vector SIMD code.

References gl::a, and gl::b.

## ◆ greaterThan()

template<typename Type >

static vMaskType JUCE_VECTOR_CALLTYPE dsp::SIMDRegister< Type >::greaterThan | ( | SIMDRegister< Type > | a,
|  | SIMDRegister< Type > | b
| ) |  |
| staticnoexcept

Returns a SIMDRegister of the corresponding integral type where each element has each bit set if the corresponding element of a is greater than to the corresponding element of b, or zero otherwise.

The result can then be used in bit operations defined above to avoid branches in vector SIMD code.

References gl::a, and gl::b.

## ◆ greaterThanOrEqual()

template<typename Type >

static vMaskType JUCE_VECTOR_CALLTYPE dsp::SIMDRegister< Type >::greaterThanOrEqual | ( | SIMDRegister< Type > | a,
|  | SIMDRegister< Type > | b
| ) |  |
| staticnoexcept

Returns a SIMDRegister of the corresponding integral type where each element has each bit set if the corresponding element of a is greater than or equal to the corresponding element of b, or zero otherwise.

The result can then be used in bit operations defined above to avoid branches in vector SIMD code.

References gl::a, and gl::b.

## ◆ min()

template<typename Type >

static SIMDRegister JUCE_VECTOR_CALLTYPE dsp::SIMDRegister< Type >::min | ( | SIMDRegister< Type > | a,
|  | SIMDRegister< Type > | b
| ) |  |
| staticnoexcept

Returns a new vector where each element is the minimum of the corresponding element of a and b.

References gl::a, and gl::b.

Referenced by jmin().

## ◆ max()

template<typename Type >

static SIMDRegister JUCE_VECTOR_CALLTYPE dsp::SIMDRegister< Type >::max | ( | SIMDRegister< Type > | a,
|  | SIMDRegister< Type > | b
| ) |  |
| staticnoexcept

Returns a new vector where each element is the maximum of the corresponding element of a and b.

References gl::a, and gl::b.

Referenced by jmax().

## ◆ multiplyAdd()

template<typename Type >

static SIMDRegister JUCE_VECTOR_CALLTYPE dsp::SIMDRegister< Type >::multiplyAdd | ( | SIMDRegister< Type > | a,
|  | const SIMDRegister< Type > | b,
|  | SIMDRegister< Type > | c
| ) |  |
| staticnoexcept

Multiplies b and c and adds the result to a.

References gl::a, gl::b, and gl::c.

## ◆ sum()

template<typename Type >

ElementType dsp::SIMDRegister< Type >::sum | ( |  | ) | const
| noexcept

Returns a scalar which is the sum of all elements of the receiver.

References dsp::SIMDRegister< Type >::value.

## ◆ truncate()

template<typename Type >

static SIMDRegister JUCE_VECTOR_CALLTYPE dsp::SIMDRegister< Type >::truncate | ( | SIMDRegister< Type > | a | ) |
| staticnoexcept

Truncates each element to its integer part.

Effectively discards the fractional part of each element. A.k.a. round to zero.

References gl::a.

## ◆ abs()

template<typename Type >

static SIMDRegister JUCE_VECTOR_CALLTYPE dsp::SIMDRegister< Type >::abs | ( | SIMDRegister< Type > | a | ) |
| staticnoexcept

Returns the absolute value of each element.

References gl::a, dsp::SIMDRegister< Type >::expand(), and dsp::SIMDRegister< Type >::lessThan().

## ◆ isSIMDAligned()

template<typename Type >

static bool dsp::SIMDRegister< Type >::isSIMDAligned | ( | const ElementType * | ptr | ) |
| staticnoexcept

Checks if the given pointer is sufficiently aligned for using SIMD operations.

References dsp::SIMDRegister< Type >::SIMDRegisterSize.

Referenced by dsp::SIMDRegister< Type >::copyToRawArray(), and dsp::SIMDRegister< Type >::fromRawArray().

## ◆ getNextSIMDAlignedPtr()

template<typename Type >

static ElementType * dsp::SIMDRegister< Type >::getNextSIMDAlignedPtr | ( | ElementType * | ptr | ) |
| staticnoexcept

Returns the next position in memory where isSIMDAligned returns true.

If the current position in memory is already aligned then this method will simply return the pointer.

References dsp::SIMDRegister< Type >::SIMDRegisterSize, and snapPointerToAlignment().

## Member Data Documentation

## ◆ SIMDRegisterSize

template<typename Type >

constexpr size_t dsp::SIMDRegister< Type >::SIMDRegisterSize = sizeof (vSIMDType)
| staticconstexpr

The size in bytes of this register.

Referenced by dsp::SIMDRegister< Type >::getNextSIMDAlignedPtr(), and dsp::SIMDRegister< Type >::isSIMDAligned().

## ◆ SIMDNumElements

template<typename Type >

constexpr size_t dsp::SIMDRegister< Type >::SIMDNumElements = SIMDRegisterSize / sizeof (ElementType)
| staticconstexpr

The number of elements that this vector can hold.

Referenced by dsp::SIMDRegister< Type >::get(), dsp::SIMDRegister< Type >::operator[](), dsp::SIMDRegister< Type >::set(), and dsp::SIMDRegister< Type >::size().

## ◆ value

template<typename Type >

vSIMDType dsp::SIMDRegister< Type >::value

Referenced by dsp::SIMDRegister< Type >::copyToRawArray(), dsp::SIMDRegister< Type >::get(), dsp::SIMDRegister< Type >::operator&(), dsp::SIMDRegister< Type >::operator&=(), dsp::SIMDRegister< Type >::operator*(), dsp::SIMDRegister< Type >::operator*=(), dsp::SIMDRegister< Type >::operator+(), dsp::SIMDRegister< Type >::operator+=(), dsp::SIMDRegister< Type >::operator-(), dsp::SIMDRegister< Type >::operator-=(), dsp::SIMDRegister< Type >::operator=(), dsp::SIMDRegister< Type >::operator==(), dsp::SIMDRegister< Type >::operator^(), dsp::SIMDRegister< Type >::operator^=(), dsp::SIMDRegister< Type >::operator|(), dsp::SIMDRegister< Type >::operator|=(), dsp::SIMDRegister< Type >::operator~(), dsp::SIMDRegister< Type >::set(), and dsp::SIMDRegister< Type >::sum().

The documentation for this struct was generated from the following file:

- juce_SIMDRegister.h